exec("./Support_LibStr.cs");
exec("./Support_EventTargets.cs");

registerEventTarget("Server ServerEventTargetSO", "", "ServerEventTargetSO.getID()");

if(!isObject(ServerEventTargetSO))
	new scriptObject(ServerEventTargetSO);

function ServerEventTargetSO::echo(%this, %val)
{
	echo(%val);
}
registerOutputEvent(ServerEventTargetSO, "echo", "string 200 176", 0);

function ServerEventTargetSO::warn(%this, %val)
{
	warn(%val);
}
registerOutputEvent(ServerEventTargetSO, "warn", "string 200 176", 0);

function ServerEventTargetSO::error(%this, %val)
{
	error(%val);
}
registerOutputEvent(ServerEventTargetSO, "error", "string 200 176", 0);

function ServerEventTargetSO::clearAllBricks(%this)
{
	%groupCount = mainBrickGroup.getCount();
	for(%i = 0; %i < %groupCount; %i ++)
		mainBrickGroup.getObject(%i).chainDeleteAll();
}
registerOutputEvent(ServerEventTargetSO, "clearAllBricks", "", 0);

function ServerEventTargetSO::loadSaveFile(%this, %fileName, %ownership)
{
	%fileName = trim(%fileName);
	if(%fileName $= "")
		return;
	if(striPos(%fileName, ".bls") == -1)
		%fileName = %fileName @ ".bls";
	if(striPos(%fileName, "/") == -1)
		%fileName = "saves/" @ %fileName;
	if(!isFile(%fileName))
		return;

	serverDirectSaveFileLoad(%fileName, 3, "", %ownership);
}
registerOutputEvent(ServerEventTargetSO, "loadSaveFile", "string 200 176" TAB "list Host 0 SavedOwner 1 Public 2", 0);

//function ServerEventTargetSO::shutDown(%this)
//{
//	if($Server::Dedicated)
//		quit();
//	else
//		destroyServer();
//}
//registerOutputEvent(ServerEventTargetSO, "shutDown", "", 0);

package Event_Server
{
	function serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %namedTargetNameIdx, %outputEventIdx, %par1, %par2, %par3, %par4)
	{
		%obj = %client.wrenchBrick;
		if(isObject(%obj))
		{
			%target = inputEvent_getTargetClass(%obj.getClassName(), %inputEventIdx, %targetIdx);
			if(%target $= "ServerEventTargetSO")
			{
				%blid = %client.getBLID();
				if(%blid !$= getNumKeyID() && (!$Server::LAN || %blid !$= getLAN_BLID()))
				{
					messageClient(%client, '', "You do not have permission to use server events.");
					return;
				}
			}
		}

		parent::serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %namedTargetNameIdx, %outputEventIdx, %par1, %par2, %par3, %par4);
	}
};
activatePackage(Event_Server);